<?php

/**
 * Custom renderer for Glopal payment group in Sales Payment Methods System Configuration
 *
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_Block_Adminhtml_System_Config_Fieldset_Payment
    extends Mage_Adminhtml_Block_System_Config_Form_Fieldset
{
    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $store = null;
        if ($this->getRequest()->getParam('store')) {
            $store = $this->getRequest()->getParam('store');
        }

        $useGlopalCheckout = Mage::getStoreConfigFlag('glopal_checkout/general/use_glopal_checkout', $store);
        $useGlopalPayment = Mage::getStoreConfigFlag('glopal_checkout/general/use_glopal_payment', $store);

        // Show configuration group only when not use Glopal checkout and Glopal as payment
        if ($useGlopalCheckout || !$useGlopalPayment) {
            return '';
        }

        return parent::render($element);
    }

    protected function _getHeaderCommentHtml($element)
    {
        $url = Mage::helper("adminhtml")->getUrl('adminhtml/system_config/edit/section/glopal_checkout');

        return "<div class='comment'>"
            . "<a href='$url'>Click here for other Glopal's Configuration</a>"
            . "</div>";
    }
}