<?php
/**
 * Head block
 *
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_Block_Head extends Glopal_Connector_Block_Template
{
    public function getHeadHtml()
    {
        return Mage::getStoreConfig('webinterpret_connector/head') . PHP_EOL;
    }

    public function getLoaderUrl()
    {
        return Mage::helper('glopal_connector')->getRemoteAssetsUrl() . '/common/js/webinterpret-loader.js';
    }

    public function getPluginVersion()
    {
        return 'magento-' . Mage::helper('glopal_connector')->getExtensionVersion();
    }

    public function isRedirectorEnabled()
    {
        return Mage::getStoreConfigFlag('webinterpret_connector/redirector_enabled');
    }

    public function getShortName()
    {
        return Mage::getStoreConfig('webinterpret_connector/short_name');
    }

}
