<?php

use Glopal_Connector_Model_SignatureException as SignatureException;

/**
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_Helper_Utils extends Mage_Core_Helper_Abstract
{
    /**
     * Builds hmac key by data and secret.
     *
     * @param string $data
     * @param string $secretKey
     * @return string
     */
    public function buildHmacKey($data, $secretKey)
    {
        return hash_hmac('sha256', $data, $secretKey);
    }
}