<?php
/**
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_Helper_V1_Order extends Mage_Core_Helper_Abstract
{
    /**
     * @var array
     */
    protected $params;

    /**
     * @return array
     * @throws InvalidArgumentException if there are issues with the request
     */
    protected function getRequestParams()
    {
        if (null != $this->params) {
            return $this->params;
        }
        $rawBody = Mage::app()->getRequest()->getRawBody();
        if ($rawBody)  {
            $body = Mage::helper('core')->jsonDecode($rawBody);
            if (empty($body)) {
                throw new InvalidArgumentException('Invalid Request params');
            }
            $this->params = $body;
            return $this->params;
        }
    }

   /**
    *  @param Mage_Sales_Model_Order $order
    * @return array
    */
    public function patchOrder($order)
    {
        $params = $this->getRequestParams();
        $updates = [];
        foreach ($params as $name => $value) {
            $updates[$name]['old'] = $order->getData($name);
            $order->setData($name, $value);
            $order->getResource()->saveAttribute($order, $name);
            $updates[$name]['new'] = $order->getData($name);
        }
        return $updates;
    }
}
