<?php
/**
 * Install Store Cron
 *
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_Model_Cron_Install
{
    /**
     * Notify about new store views via Magento cron
     */
    public function notifyStores()
    {
        $shouldNotify = false;
        $stores = Mage::app()->getStores();

        foreach( $stores as $store ) {
            $storeId = $store->getStoreId();
            if( ! Mage::helper('glopal_connector/instalation')->isStoreInstallationNotified( $storeId ) ) {
                $shouldNotify = true;
            }
        }

        if( $shouldNotify ) {
            Mage::helper('glopal_connector/instalation')->notifyInstalation();
        }
    }
}
