<?php

class Glopal_Connector_Model_Invoice_Totals extends Mage_Sales_Model_Order_Invoice_Total_Subtotal
{
    /**
     * Magento will get the totalpaid amount and add the invoiced amount and set the totalpaid to the new value.
     * This results in a double totalPaid value within the order view. This happens only when auto creation of
     * the invoice is disabled or Glopal paid amount is not matching magento order grand total.
     * To fix this we will set the Total Paid to 0 before the invoice is created.
     * and the totalpaid is update again with the total invoiced.
     *
     * @param Mage_Sales_Model_Order_Invoice $invoice
     * @return $this|Glopal_Connector_Model_Invoice_Totals
     */
    public function collect(Mage_Sales_Model_Order_Invoice $invoice)
    {
        /** @var Mage_Sales_Model_Order $order */
        $order = $invoice->getOrder();
        if ($order->getData('glopal_order_id')) {
            $order->setTotalPaid(0);
            $order->setBaseTotalPaid(0);

            $invoice->setBaseGrandTotal($invoice->getBaseGrandTotal());
            $invoice->setGrandTotal($invoice->getGrandTotal());
            $invoice->setSubtotalInclTax($invoice->getSubtotalInclTax());
            $invoice->setBaseSubtotalInclTax($invoice->getBaseSubtotalInclTax());

            return $this;
        }

        return parent::collect($invoice);
    }
}
