<?php

class Glopal_Connector_Model_System_Config_Source_Attributes
{
    private $productAttributes = [];

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $this->loadAttributes();

        return $this->productAttributes;
    }

    /**
     * Get options in "key-value" format
     *
     * @return array
     */
    public function toArray()
    {
        $this->loadAttributes();

        return $this->productAttributes;
    }

    private function loadAttributes()
    {
        if (!empty($this->productAttributes)) {
            return;
        }

        /** @var Mage_Catalog_Model_Resource_Product_Attribute_Collection $productAttributesCollection */
        $productAttributesCollection = Mage::getResourceModel('catalog/product_attribute_collection')->load();
        foreach ($productAttributesCollection as $attribute) {
            if (!empty($attribute->getFrontendLabel())) {
                $this->productAttributes[$attribute->getAttributeCode()] = $attribute->getFrontendLabel()
                    . ' ('
                    . $attribute->getAttributeCode()
                    . ')';
            }
        }
    }

}
