<?php

/**
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_HelperController extends Mage_Core_Controller_Front_Action
{
    public function indexAction()
    {
        try {
            Glopal_Connector_Helper_Verifier::verifyRequestWebInterpretSignature();
            define('M1_TOKEN', Mage::helper('glopal_connector')->getGlopalKey());
            $dir = Mage::helper('glopal_connector')->getModuleBridgeDir();
            $path = $dir . DS . 'helper.php';
            if (!file_exists($path)) {
                $this->_forward('defaultNoRoute');
                return;
            }
            require_once $path;
            Glopal_Bridge2Cart_Helper::handleRequest();
        } catch (Glopal_Connector_Model_SignatureException $e) {
            header('HTTP/1.0 403 Forbidden');
            echo $e->getMessage();
        } catch (Exception $e) {
            echo $e->getMessage();
        }
        die;
    }

    public function installAction()
    {
        try {
            Glopal_Connector_Helper_Verifier::verifyRequestWebInterpretSignature();
            $response = array();
            $response['status'] = 'success';
            $response['response_id'] = md5(uniqid(mt_rand(), true));
            if (!Mage::helper('glopal_connector')->installBridgeHelper()) {
                $response['status'] = 'error';
            }
            header('Content-Type: application/json');
            echo json_encode($response);
        } catch (Glopal_Connector_Model_SignatureException $e) {
            header('HTTP/1.0 403 Forbidden');
            echo $e->getMessage();
        } catch (Exception $e) {
            echo $e->getMessage();
        }
        die;
    }
}
