<?php

/**
 * @category   Glopal
 * @package    Glopal_Connector
 * @author     Glopal Team <support@glopal.com>
 * @license    http://opensource.org/licenses/osl-3.0.php
 */
class Glopal_Connector_IndexController extends Mage_Core_Controller_Front_Action
{
    public function indexAction()
    {
        try {
            Glopal_Connector_Helper_Verifier::verifyRequestWebInterpretSignature();
            define('M1_TOKEN', Mage::helper('glopal_connector')->getGlopalKey());
            define('M1_BRIDGE_DOWNLOAD_LINK', (string)Mage::getStoreConfig('bridge_file_update_url'));
            define('M1_STORE_BASE_DIR', Mage::getBaseDir('base') . DS);
            $dir = Mage::helper('glopal_connector')->getModuleBridgeDir();
            $path = $dir . DS . 'bridge.php';
            if (!file_exists($path)) {
                $this->_forward('defaultNoRoute');
                return;
            }
            require_once $path;
        } catch (Glopal_Connector_Model_SignatureException $e) {
            header('HTTP/1.0 403 Forbidden');
            echo $e->getMessage();
        } catch (Exception $e) {
            echo $e->getMessage();
        }
        die;
    }
}
