<?php

require_once('AbstractController.php');

class Glopal_Connector_OrderController extends Glopal_Connector_AbstractController
{
    /**
     * @return array
     * @throws InvalidArgumentException if a different request method type is used
     */
    protected function process()
    {
        if ($this->getRequest()->isPost()) {
            $isPatch = $this->getRequest()->getParam('patch', false);
            if ($isPatch === false) {
            } else {
                return $this->patchOrder();
            }
        }
        if ($this->getRequest()->isPatch()) {
            return $this->patchOrder();
        }
        throw new InvalidArgumentException('Wrong method used');
    }

    /**
     * @return array
     * @throws InvalidArgumentException if the order is not found
     */
    protected function patchOrder()
    {
        $orderId = $this->getRequest()->getParam('order_id', null);
        if (empty($orderId)) {
            throw new InvalidArgumentException('Invalid order id provided');
        }
        $order = Mage::getModel('sales/order')->load($orderId);
        if (null == $order->getId()) {
            throw new InvalidArgumentException('Order does not exists');
        }
        $updates = Mage::helper('glopal_connector/v1_order')->patchOrder($order);
        return $updates;
    }
}
